#include <iostream>
#include <opencv2/opencv.hpp>




#include <cstdio>
#include <cstring>


using namespace std;
using namespace cv;
 
int main (int argc, const char * argv[])
{
    
    
       
    VideoCapture cap(CV_CAP_ANY);
    cap.set(CV_CAP_PROP_FRAME_WIDTH,160);
    cap.set(CV_CAP_PROP_FRAME_HEIGHT,120);    
    if (!cap.isOpened())
        return -1;
 
    Mat img;
    HOGDescriptor hog;
    hog.setSVMDetector(HOGDescriptor::getDefaultPeopleDetector());
    int people=0;
    
    namedWindow("video capture", CV_WINDOW_AUTOSIZE);
    while (true)
    {
        cap >> img;
        if (!img.data)
            continue;
 
        vector<Rect> found, found_filtered;
        hog.detectMultiScale(img, found, 0, Size(8,8), Size(32,32), 1.05, 0);
 
        size_t i, j;
        for (i=0; i<found.size(); i++)
        {
            Rect r = found[i];
            for (j=0; j<found.size(); j++)
                if (j!=i && (r & found[j])==r)            
              		{
			
                        break;
			}
                
            if (j==found.size())
                found_filtered.push_back(r);               
            
        }
       
       
        for (i=0; i<found_filtered.size(); i++)
        {
	    Rect r = found_filtered[i];
            r.x += cvRound(r.width*0.1);
	    r.width = cvRound(r.width*0.8);
	    r.y += cvRound(r.height*0.06);
	    r.height = cvRound(r.height*0.9);
	    rectangle(img, r.tl(), r.br(), cv::Scalar(0,255,0), 2);             
	} 
        
        imshow("video capture", img);
       
         char buffer[100];
        if(found_filtered.size()>0){
            people++;
            std::cout << "ROI has counted " << people << " people. Found"<<found.size() << std::endl;
            sprintf(buffer, "mosquitto_pub -h 192.168.1.16 -t /sensor/video -m %d/%d", people, found.size());
            std::cout << "command " << buffer      << std::endl;
            FILE * f = popen(buffer, "w" );
            if ( f == 0 ) {
                fprintf( stderr, "Could not execute\n" );
                return 1;
            }
        const int BUFSIZE = 1000;
        char buf[ BUFSIZE ];
        while( fgets( buf, BUFSIZE,  f ) ) {
                fprintf( stdout, "%s", buf  );
        }
        pclose( f );
        }
        if (waitKey(20) >= 0)
            break;
    }
    
    return 0;
}
